config/routes.rb
Rails.application.routes.draw do
  resources :programming_languages, only: [:index]
  resources :repositories, only: [:index]
  resources :employees, only: [:index]
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "employees#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/employee.rb
class Employee < ApplicationRecord
  has_and_belongs_to_many :repositories

  validates :login, presence: true

  def programming_languages
    self.repositories
        .map(&:programming_languages)
        .flatten
        .inject(Hash.new(0)) do |total, element|
          total[element.name] += 1
          total
        end
  end
end

app/models/programming_language.rb
class ProgrammingLanguage < ApplicationRecord
  has_and_belongs_to_many :repositories

  validates :name, presence: true
end

app/models/repository.rb
class Repository < ApplicationRecord
  has_and_belongs_to_many :contributors, class_name: 'Employee'
  has_and_belongs_to_many :programming_languages

  validates :name, presence: true
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/employees_controller.rb
class EmployeesController < ApplicationController
  def index
    @programming_languages = ProgrammingLanguage.all
    params[:programming_languages] ||= []

    @employees = Employee.select do |employee|
      (employee.programming_languages.keys & params[:programming_languages]).sort == params[:programming_languages].sort
    end

    respond_to do |format|
      format.html {}
      format.json {}
      format.yaml do
        render inline: (@employees.each_with_object({}) do |employee, employees|
                         employees[employee[:login]] = employee.programming_languages
                       end).to_yaml
      end
    end
  end
end

app/controllers/programming_languages_controller.rb
class ProgrammingLanguagesController < ApplicationController
  def index
    @programming_languages = ProgrammingLanguage.all
  end
end

app/controllers/repositories_controller.rb
class RepositoriesController < ApplicationController
  def index
    @repositories = Repository.all
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/employees_helper.rb
module EmployeesHelper
end

app/helpers/programming_languages_helper.rb
module ProgrammingLanguagesHelper
end

app/helpers/repositories_helper.rb
module RepositoriesHelper
end

app/views/employees/index.html.erb
<section>
  <header>
    <h2><%= pluralize(@employees.count, 'employee') %></h2>
    <p>
      <% @programming_languages&.each do |programming_language| %>
        <% if params[:programming_languages]&.include?(programming_language.name) %>
          <a href="<%= employees_path(programming_languages: (params[:programming_languages] - [programming_language.name])) %>"><b><%= programming_language.name %></b></a>
        <% else %>
          <a href="<%= employees_path(programming_languages: (params[:programming_languages] + [programming_language.name])) %>"><i><%= programming_language.name %></i></a>
        <% end %>
      <% end %>
    </p>
  </header>
  <% @employees.each do |employee| %>
    <aside>
      <img alt="<%= employee.login %>" src="https://avatars.githubusercontent.com/u/<%= employee.id %>?v=4" height="128">
      <h2><%= employee.login %></h2>
      <p>
      <% employee.programming_languages.each do |programming_language, count| %>
        <sup><%= programming_language %>&nbsp;(<%= count %>)</sup>
      <% end %>
      </p>
    </aside>
  <% end %>
</section>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html color-mode="user">
  <head>
    <title>Programming Languages</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <header>
      <nav>
         <a href="/"><img alt="Logo" src="https://blog.codecentric.de/_next/image?url=https%3A%2F%2Fmedia.graphassets.com%2Foutput%3Dformat%3Awebp%2FeKL6w2cpTlK3MOgSFsvR&w=1200&q=75" height="25"></a>
         <ul>
           <li><a href="<%= employees_path %>">Employees</a></li>
           <li><a href="<%= repositories_path %>">Repositories</a></li>
           <li><a href="<%= programming_languages_path %>">Languages</a></li>
         </ul>
      </nav>
    </header>
    <main>
      <%= yield %>
    </main>
  </body>
</html>

app/views/programming_languages/index.html.erb
<section>
  <header>
    <h2><%= pluralize(@programming_languages.count, 'programming language') %></h2>
  </header>
  <% @programming_languages.each do |programming_language| %>
    <aside>
      <h2><%= programming_language.name %></h2>
      <p>
        <%= pluralize(programming_language.repositories.count, 'repository') %>
      </p>
    </aside>
  <% end %>
</section>

app/views/repositories/index.html.erb
<section>
  <header>
    <h2><%= pluralize(@repositories.count, 'repository') %></h2>
  </header>
  <% @repositories.each do |repository| %>
    <aside>
      <h2><%= repository.name %></h2>
      <p>
        <%= pluralize(repository.contributors.count, 'contributor') %>
      </p>
      <p>
        <% if repository.programming_languages.any? %>
          Languages:
          <ul>
            <% repository.programming_languages.each do |programming_language| %>
              <li><%= programming_language.name %></li>
            <% end %>
          </ul>
        <% end %>
      </p>
    </aside>
  <% end %>
</section>